#ifdef __cplusplus
     #define EXPORTS extern "C" __declspec (dllimport)
#else
     #define EXPORTS
#endif

// return code
#define FRB_NoError                     0
#define FRB_DriverOpenError             1
#define FRB_DriverNoOpen                2
#define FRB_GetDriverVersionError       3
#define FRB_FindBoardError              4
#define FRB_ExceedBoardNumber           5
#define FRB_InputParameterError         6
#define FRB_DelayTimeOut                7

//AO Config Code
#define FRB_AO_20MA       0x30   // 0 ~ 20 mA
#define FRB_AO_4_20MA     0x31   // 4 ~ 20 mA
#define FRB_AO_UNI_10V    0x32   // 0 ~ 10 V
#define FRB_AO_BI_10V     0x33   // +/- 10 V
#define FRB_AO_UNI_5V     0x34   // 0 ~  5 V
#define FRB_AO_BI_5V      0x35   // +/-  5 V

//AI Config Code
#define FRB_AI_20MA       0x1A   // 0 ~ 20 mA
#define FRB_AI_4_20MA     0x07   // 4 ~ 20 mA
#define FRB_AI_BI_10V     0x08   // +/- 10 V
#define FRB_AI_BI_5V      0x09   // +/-  5 V
#define FRB_AI_BI_1V      0x0A   // +/-  1 V
#define FRB_AI_BI_0V5     0x0B   // +/-500 mA
#define FRB_AI_BI_0V15    0x0C   // +/-150 mA 
#define FRB_AI_BI_0V02    0x0D   // +/- 20 mA

EXPORTS WORD   CALLBACK FRB_GetDllVersion(void);
EXPORTS WORD   CALLBACK FRB_DriverInit(WORD *wTotalBoard);
EXPORTS void   CALLBACK FRB_DriverClose(void);
EXPORTS WORD   CALLBACK FRB_GetDriverVersion(WORD *wDriverVersion);
EXPORTS WORD   CALLBACK FRB_ActiveBoard( WORD wBoardNo );

EXPORTS WORD   CALLBACK FRB_SendSA(WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_ReceiveRA(WORD wPort, WORD RAn, WORD *wInputData);
EXPORTS WORD   CALLBACK FRB_Write_DO(WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_Read_DI(WORD wPort, WORD RAn, WORD *wInputData);
EXPORTS WORD   CALLBACK FRB_DIO_Write_DO(WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_DIO_Read_DI(WORD wPort, WORD RAn, WORD *wInputData);

EXPORTS WORD   CALLBACK FRB_WriteAOHex(WORD wPort, WORD SAn, WORD wChannel, WORD wResoultion, WORD wOutputData, WORD wDelay);
EXPORTS WORD   CALLBACK FRB_WriteAOFloat(WORD wPort, WORD SAn, WORD wChannel, WORD wResoultion, WORD wConfigCode,float fOutputData,WORD wDelay);

EXPORTS WORD   CALLBACK FRB_ReadAI_CH(WORD wPort, WORD RAn, WORD wResoultion, WORD wConfigCode, WORD wChannel, float* fValue);
EXPORTS WORD   CALLBACK FRB_ReadAI_CHScan(WORD wPort, WORD RAn, WORD wResoultion, WORD wInputType, WORD wConfigCodeList[],  float fValue[]);
//EXPORTS WORD   CALLBACK FRB_ReadAIHex(WORD wPort, WORD SAn,int port,int group,short bitMode,short *chIndex, short* aiHex)

EXPORTS WORD   CALLBACK FRB_ReadRAStatus(WORD wPort,BYTE *bRAStatus);

//EXPORTS void   CALLBACK FRB_OutputByte(DWORD wPortAddr, WORD bOutputValue);
//EXPORTS WORD   CALLBACK FRB_InputByte(DWORD wPortAddr);
EXPORTS WORD   CALLBACK FRB_GetConfigAddressSpace(WORD  wBoardNo, DWORD *wAddrBase, WORD *wIrqNo,
                           WORD *wSubVendor, WORD *wSubDevice, WORD *wSubAux,
                           WORD *wSlotBus,   WORD *wSlotDevice);

// Board Number Select
EXPORTS WORD   CALLBACK FRB_SendSABoard(WORD wBoardNo, WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_ReceiveRABoard(WORD wBoardNo, WORD wPort, WORD RAn, WORD *wInputData);
EXPORTS WORD   CALLBACK FRB_Write_DOBoard(WORD wBoardNo, WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_Read_DIBoard(WORD wBoardNo, WORD wPort, WORD RAn, WORD *wInputData);
EXPORTS WORD   CALLBACK FRB_DIO_Write_DOBoard(WORD wBoardNo, WORD wPort, WORD SAn, WORD wOutputData);
EXPORTS WORD   CALLBACK FRB_DIO_Read_DIBoard(WORD wBoardNo, WORD wPort, WORD RAn, WORD *wInputData);

EXPORTS WORD   CALLBACK FRB_WriteAOHexBoard(WORD wBoardNo, WORD wPort, WORD SAn, WORD wChannel, WORD wResoultion, WORD wOutputData, WORD wDelay);
EXPORTS WORD   CALLBACK FRB_WriteAOFloatBoard(WORD wBoardNo, WORD wPort, WORD SAn, WORD wChannel, WORD wResoultion, WORD wConfigCode,float fOutputData,WORD wDelay);

EXPORTS WORD   CALLBACK FRB_ReadAI_CHBoard(WORD wBoardNo, WORD wPort, WORD RAn, WORD wResoultion, WORD wConfigCode, WORD wChannel, float* fValue);
EXPORTS WORD   CALLBACK FRB_ReadAI_CHScanBoard(WORD wBoardNo, WORD wPort, WORD RAn, WORD wResoultion, WORD wInputType, WORD wConfigCodeList[],  float fValue[]);
//EXPORTS WORD   CALLBACK FRB_ReadAIHexBoard(WORD wBoardNo, WORD wPort, WORD SAn,int port,int group,short bitMode,short *chIndex, short* aiHex)

EXPORTS WORD   CALLBACK FRB_ReadRAStatusBoard(WORD wBoardNo, WORD wPort,BYTE *bRAStatus);

